//+------------------------------------------------------------------+
//|                                                    TSI_Metod.mq4 |
//|                                                 Kamil Gazizullin |
//|                                             forexman77@yandex.ru |
//+------------------------------------------------------------------+
#property copyright "QuantF"
#property link      "quantumtrade7@gmail.com"
#property indicator_separate_window
#property indicator_buffers 9
#property indicator_color1  Blue
#property indicator_level1 -25           //   #0   
#property indicator_level2 25            //   #1   
#property indicator_level3 0           
//--- input parameters
extern int       Period_MA_r=14;
extern int       r2 =7;
extern int       r3 =5;
extern int       r4 =3;
extern ENUM_MA_METHOD Method=MODE_EMA;
//--- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];
double ExtMapBuffer9[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexBuffer(7,ExtMapBuffer8);
   SetIndexBuffer(8,ExtMapBuffer9); 
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
   SetIndexLabel(3,NULL);
   SetIndexLabel(4,NULL);
   SetIndexLabel(5,NULL);
   SetIndexLabel(6,NULL);
   SetIndexLabel(7,NULL);
   SetIndexLabel(8,NULL);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted(),
   i,limit1;
   limit1=Bars-counted_bars-1;
 
   for(i=limit1;i>=0;i--) ExtMapBuffer2[i]=Close[i]-Close[i+Period_MA_r];
   for(i=limit1;i>=0;i--) ExtMapBuffer3[i]=MathAbs(Close[i]-Close[i+Period_MA_r]);
   for(i=limit1;i>=0;i--) ExtMapBuffer4[i]=iMAOnArray(ExtMapBuffer2,0,r2,0, Method,i);
   for(i=limit1;i>=0;i--) ExtMapBuffer5[i]=iMAOnArray(ExtMapBuffer3,0,r2,0, Method,i);
   for(i=limit1;i>=0;i--) ExtMapBuffer6[i]=iMAOnArray(ExtMapBuffer4,0,r3,0, Method,i);
   for(i=limit1;i>=0;i--) ExtMapBuffer7[i]=iMAOnArray(ExtMapBuffer5,0,r3,0, Method,i);
   for(i=limit1;i>=0;i--) ExtMapBuffer8[i]=iMAOnArray(ExtMapBuffer6,0,r4,0, Method,i);
   for(i=limit1;i>=0;i--) ExtMapBuffer9[i]=iMAOnArray(ExtMapBuffer7,0,r4,0, Method,i);
   for(i=limit1;i>=0;i--){ExtMapBuffer1[i]=100*ExtMapBuffer8[i]/ExtMapBuffer9[i];} 
   return(0);
  }
//+------------------------------------------------------------------+
